unit Data;

interface

uses
  Classes, SysUtils, WinSock;

type
   TDataThread = class(TThread)
   protected
      ShowAll     : boolean;
      procedure   Execute; override;
      procedure   GetCommands;
      procedure   ShowProcesses;
      procedure   KillProcess(pid: integer);
   public
      DataSock    : TSocket;
      RemoteHost  : string;
   end;

implementation

uses SockUtil, Windows, Messages;

{ TDataThread }

const
   CR = #13#10;

procedure TDataThread.Execute;
var
   pw : string;
begin
   try
      PutLine(DataSock, 'Remote Admin');
      PutLine(DataSock, 'Enter Password:');
      pw := GetLineCR(DataSock, True, True);
      Sleep(100);
      if pw<>'zadmin' then raise Exception.Create('Bad Password');

      GetCommands;
   except
   end;
   closesocket(DataSock);
end;

procedure TDataThread.GetCommands;
var
   s     : string;
   arg   : string;
   i     : integer;
   sl    : TStringList;
   rc    : boolean;
   p     : integer;
   tmp   : string;
   buf   : array[0..MAX_PATH] of char;
   path  : string;
   sr    : TSearchRec;
   dt    : TDateTime;
   ft    : TFileTime;
   st    : TSystemTime;
   pid   : integer;
   wh    : integer;
   StartInfo   : TStartupInfo;
   ProcInfo    : TProcessInformation;
begin
   repeat
      PutLine(DataSock, '');
      PutLine(DataSock, 'Enter Command:   (' + FormatDateTime('mmm dd hh:nn:ss ampm', Now)+')');
      s := UpperCase(GetLineCR(DataSock, True, False));

      p := Pos(' ', s);
      Arg := '';
      if p<>0 then begin
         Arg := Copy(s, p+1, Length(s));
         s := Copy(s, 1, p-1);
      end;

      if s='EXIT' then exit;

      if (s='HELP') or (s='?') then begin
         PutLine(DataSock, 'EXIT, HELP, PWD, CD, DIR, PS, PSALL');
         PutLine(DataSock, 'TYPE, KILL, CLOSEWIN, START');
         continue;
      end;

      if s = 'START' then begin
         GetStartupInfo(StartInfo);
         rc := CreateProcess(nil, PChar(Arg), nil, nil, False, 0,
            nil, nil, StartInfo, ProcInfo);
         if not rc then PutLine(DataSock, 'START Failed!');
      end;

      if s = 'TYPE' then begin
         sl := TStringList.Create;
         try
            sl.LoadFromFile(Arg);
            for i := 0 to sl.Count-1 do
               PutLine(DataSock, sl[i]);
         except
            sl.Free;
         end;
      end;

      if s = 'KILL' then begin
         try
            pid := StrToInt('$'+Arg);
         except
            pid := -1;
         end;
         if pid<>-1 then KillProcess(pid);
      end;

      if s = 'CLOSEWIN' then begin
         try
            wh := StrToInt('$'+Arg);
         except
            wh := -1;
         end;
         if wh<>-1 then SendMessage(wh, WM_CLOSE, 0, 0);
      end;

      if s='PS' then begin
         ShowAll := False;
         ShowProcesses;
         continue;
      end;

      if s='PSALL' then begin
         ShowAll := True;
         ShowProcesses;
         continue;
      end;

      if s = 'CD' then begin
         StrPCopy(buf, Arg);
         SetCurrentDirectory(buf);

         GetCurrentDirectory(sizeof(buf), buf);
         PutLine(DataSock, 'CWD = ' + buf);
         continue;
      end;

      if s='PWD' then begin
         GetCurrentDirectory(sizeof(buf), buf);
         PutLine(DataSock, 'CWD = ' + buf);
         continue;
      end;

      if s = 'DIR' then begin
         tmp := Arg;
         if tmp='' then tmp := '*.*';

         GetCurrentDirectory(sizeof(buf), buf);
         PutLine(DataSock, 'CWD = ' + buf);

         path := buf;
         if Copy(path, Length(path), 1)<>'\' then path := path + '\';
         if FindFirst(path+tmp, faAnyFile, sr)=0 then repeat
            tmp := sr.Name;
            if (sr.Attr and faDirectory)<>0 then tmp := tmp + '\';
            ft := sr.FindData.ftLastAccessTime;
            FileTimeToSystemTime(ft, st);
            dt := SystemTimeToDateTime(st);
            s := Format('%10.0n   %s   %s', [sr.Size+0.0, FormatDateTime('mm/dd/yy hh:nn:ss', dt), tmp]);
            PutLine(DataSock, s);
         until FindNext(sr)<>0;
         continue;
      end;

   until False;
end;

function EnumWinProc(Handle: THandle; LParam: integer): boolean; stdcall;
var
   dt  : TDataThread;
   buf : array[0..MAX_PATH] of char;
   pid : integer;
   hp  : THandle;
   pc  : integer;
   s   : string;
begin
   Result := True;
   dt := TDataThread(LParam);
   GetWindowText(Handle, buf, sizeof(buf));

   if Length(buf)=0 then exit;

   if (not IsWindowVisible(Handle)) and (not dt.ShowAll) then exit;

   GetWindowThreadProcessId(Handle, @pid);

   hp := OpenProcess(PROCESS_ALL_ACCESS, False, pid);
   pc := GetPriorityClass(hp);
   CloseHandle(hp);

   s := Format('%8.8x  %3d  %4.4x  %-40s', [Handle, pc, pid, buf, pid]);
   PutLine(dt.DataSock, s);
end;

procedure TDataThread.ShowProcesses;
var
   s : string;
begin
   s := Format('%-8s  %-3s  %-4s  %-40s', ['WinHan', 'PRI', 'PID', 'APP NAME']);
   PutLine(DataSock, s);
   EnumWindows(@EnumWinProc, integer(Self));
end;

procedure TDataThread.KillProcess(pid: integer);
var
   hp : THandle;
begin
   hp := OpenProcess(PROCESS_ALL_ACCESS, False, pid);
   TerminateProcess(hp, -1);
   CloseHandle(hp); 
end;


end.
